unit Unit1; //main form.
//todo open the file and read wind parameters (degress or names) for diplay
//add image to show the wind angle
{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  LResources, EditBtn,  ComCtrls, StdCtrls, Menus,about,Diagnostics,settings,IniFiles;

type

  { TMainForm }

  TMainForm = class(TForm)
    Date: TDateEdit;
    imgLogo: TImage;
    lblMessage: TLabel;
    lblVessel: TLabel;
    lblVesselname: TLabel;
    lblWindUnitCaption: TLabel;
    lblWindMeasure: TLabel;
    lblWindUnits: TLabel;
    lblWindDisplay: TLabel;
    MainMenu: TMainMenu;
    mnSettings: TMenuItem;
    mnDiagnostics: TMenuItem;
    mnAbout: TMenuItem;
    ProgressBar1: TProgressBar;
    Time: TTimeEdit;
    Timer1: TTimer;
    Timer2: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure mnAboutClick(Sender: TObject);
    procedure mnDiagnosticsClick(Sender: TObject);
    procedure mnSettingsClick(Sender: TObject);

    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { private declarations }


  public
     complete:boolean;
    { public declarations }

  end;

var
  MainForm: TMainForm;
     today:Tdatetime;
implementation
  function Wind_Name(degree:real):string;  forward;
{$R *.lfm}

{ TMainForm }

procedure TMainForm.FormCreate(Sender: TObject);

begin
  complete:=false;
  today:=now();
  Time.enabled:=false;
  Date.enabled:=false;
  Time.Time:=today;
  Date.date:=today;
  lblvesselname.caption:='Vessel Name';
  lblvessel.caption:='';
  lblvessel.Enabled:=False;
  lblvesselname.Enabled:=false;
  lblvessel.Visible :=false;
  lblvesselname.Visible:=false;

  lblWindUnitCaption.Visible:=false;
   lblWindUnits.Visible:=false;
   lblWindMeasure.Visible:=false;
   lblWindDisplay.Visible:=false;

   progressbar1.Position:=1;
   Timer1.Enabled:=True;
   progressbar1.Max :=100;
   mnSettings.Enabled :=false;
   mnDiagnostics.Enabled :=false;

end;

procedure TMainForm.mnAboutClick(Sender: TObject);
begin
       frmAbout.show();
end;

procedure TMainForm.mnDiagnosticsClick(Sender: TObject);
begin
  frmDiagnostics.Show();
end;

procedure TMainForm.mnSettingsClick(Sender: TObject);
begin
  frmsettings.show();
end;



procedure TMainForm.Timer1Timer(Sender: TObject);

begin
  progressbar1.position:=progressbar1.position+10;
  lblmessage.caption:='Please Wait until System Initialized';
  if progressbar1.position >=progressbar1.Max  then
  begin
    Timer1.Enabled:=false;
    lblmessage.caption:='';
     mnSettings.Enabled :=true;
     mnDiagnostics.Enabled :=True;
     complete:=true;
  end;

end;

procedure TMainForm.Timer2Timer(Sender: TObject);
var
INI: TINIFile;
s:string;
units:integer;
begin
    today:=now();
    Time.Time:=today;
    if complete then
    begin
      progressbar1.Enabled :=false;
      progressbar1.Visible :=false;
      lblWindUnitCaption.Visible:=true;

   lblWindUnits.Visible:=true;
   lblWindMeasure.Visible:=true;
   lblWindDisplay.Visible:=true;
     INI := TINIFile.Create('data.txt');
  try
    // Open the file for reading
       s:=ini.ReadString('Parameters','Vessel Name','');
       if (s<>'') then
       begin
        lblVessel.caption:=s; //only the name appears
        lblvessel.Visible :=true;
        lblvessel.Enabled :=true;
       end;
       s:=ini.ReadString('Parameters','Main Form Vessel Name','');
        if( strtobool(s)=true) then
        begin
         lblVessel.Visible :=true;
           lblVesselname.visible:=true;
           lblvesselname.Enabled :=true;
        end
        else
        begin
        lblVessel.visible:=false;
        lblVesselname.visible:=false;
             end;
     s:=ini.ReadString('Parameters','Wind Display','');
       if (s<>'') then
       begin
        if (s='Wind Direction') then
        begin
          lblwindDisplay.caption:='Wind Direction Name';
        end;
        if (s='Abbrevation') then
        begin
        lblWindDisplay.caption:='Short Names'
        end;
        end;
         units:=ini.Readinteger('Parameters','Wind Speed Unit',units);
         case units of
         0:lblWindUnits.caption:='m/s';
         1:lblWindUnits.caption:='Km/s';
         2:lblWindUnits.caption:='knots';
         3:lblWindUnits.caption:='beaufort';
         end;
  except
    on E: EInOutError do
     showmessage('File handling error occurred. Details: '+ E.Message);
  end;

    ini.free();
    //test only
   s:=Wind_Name(50.5)
   end;
   end;



 //find wind name from Degress of sensor

function Wind_Name(degree:real):string;
  var
  Short_Wind_Name: Array [1..16] of string=('N','NNE','NE','ENE','E','ESE','SE','SSE','S','SSW','SW','WSW','W','WNW','NW','NNW');
  Long_Wind_Name:Array[1..16] of string=('North','North-Northeast',' Northeast','East-Northeast','East','East-Southeast','Southeast','South-Southeast','South','South-Southwest','Southwest','West-Southwest','West','West-Northwest','Northwest','North-Northwest');
  Wind_Angles:Array[1..16] of real=(0.0,22.5,45.0,67.5,90,112.5,135,157.5,180,202.5,225,247.5,270,292.5,315,337.5);
  count,position : integer;
  begin
   for count:=1 to 16
      do
      begin
      if degree < Wind_Angles[count] then
  begin //
   break;
  end;
  end;

   if   lblWindDisplay.Caption='Wind Direction Name' then
   begin
   Wind_Name:=Long_Wind_name[count-1];
  end;
  if lblWindDisplay.caption='Short Names' then
  begin
     Wind_Name:=Short_Wind_name[count-1];
  end;
  end;

end.

